;Programme par Denis Duplan (denis_duplan@yahoo.fr)
;Cette oeuvre est mise  disposition selon les termes de la Licence Creative Commons Attribution (http://creativecommons.org/licenses/by-nc-sa/4.0/fr/) - Pas dUtilisation Commerciale - Partage dans les Mmes Conditions 4.0 France

;Coded by Yragael
	section prg,code_c
	include "sources:darkdata/registres.s"

;*************** INDEX FONCTIONS ***************

openlibrary=-552
forbid=-132
permit=-138
allocmem=-198
freemem=-210

;*************** PARAMETRES DE L'ECRAN (INTRO) ***************

intro_nbplane=3
intro_sizex=640
intro_sizey=200

intro_startx=129				;depart horizontal du trac
intro_starty=50				;depart vertical du trac

intro_tracex=640				;largeur de l'image a tracer  ...
					;... partir de startx

intro_displayx=640			;largeur de l'image a visualiser  ...
					;... partir de startdisplayx
intro_displayy=intro_sizey			;hauteur de l'image a visualiser  ...
					;... partir de starty

intro_startdisplayx=129			;debut horizontal visible de l'image

intro_stopx=intro_displayx/2+intro_startdisplayx-256	;fin horizontale visible de l'image 
intro_stopy=intro_displayy+intro_starty-256		;fin verticale visible de l'image

intro_ddf_strt=(intro_startx-9)/2 
intro_ddf_stop=intro_ddf_strt+(intro_tracex/4-8)

intro_modulo_pair=(intro_sizex-intro_tracex)/8
intro_modulo_impair=(intro_sizex-intro_tracex)/8

intro_planesize=intro_sizey*intro_sizex/8

;*************** PARAMETRES DU SCREEN GLOBAL (PRINCIPAL) ***************

sizey=200+10+16+1

startx=129				;depart horizontal du trac
starty=50				;depart vertical du trac

displayy=sizey				;hauteur de l'image a visualiser  ...
					;... partir de starty

startdisplayx=129			;debut horizontal visible de l'image

stopy=displayy+starty-256		;fin verticale visible de l'image

;*************** PARAMETRES DES ECRANS (PRINCIPAL) ***************

nbplane0=4
sizex0=320
sizey0=200
screen0size=sizex0*sizey0/8
displayx0=320
tracex0=320
stopx0=displayx0+startdisplayx-256
ddf_strt0=(startx-17)/2 
ddf_stop0=ddf_strt0+(tracex0/2-8)
modulo_pair0=(sizex0-tracex0)/8			;0 et 2 en pair
modulo_impair0=(sizex0-tracex0)/8+sizex0/8	;1 et 3 en impair

nbplane1=2
sizex1=320+16
sizey1=16
screen1size=sizex1*sizey1/8
displayx1=320
tracex1=320
stopx1=displayx1+startdisplayx-256
ddf_strt1=(startx-17)/2
ddf_stop1=ddf_strt1+(tracex1/2-8)
modulo_pair1=(sizex1-tracex1)/8+(nbplane1-1)*sizex1/8
modulo_impair1=(sizex1-tracex1)/8+(nbplane1-1)*sizex1/8

starty0=starty
starty1=starty0+sizey0+10+1

;*************** FICHIERS ***************

fontsizex=320
fontsizey=48
fontsize=fontsizex*fontsizey/8
fontplane=2
picsizex=640
picsizey=200
picsize=picsizex*picsizey/8
bobsizex=128
bobsizey=63

;*************** CONSTANTES ***************

nbcurve=5
scrollspeed=4
timer=300
ecarty=4
font8sizey=7		;nb de pixels utilises en vertical !!! 8 pour 'y'
deltax=160
deltay=100-ecarty*(2*font8sizey-1)/2
amplitudex=160
amplitudey=deltay-4
memory=$10000+2
colortimer0=15
colortimer1=20
delaytimer0=150
introtimer=500

cop1size=8*4+9*4+2*4+intro_nbplane*8+4

;8*4 (couleurs)
;9*4 (parametres screen)
;2*4 (compatiblit AGA janvier 2003)
;intro_nbplane*8 (adresses bitplanes)
;4 ($FFFFFFFE)

cop0size=8*4+9*4+2*4+intro_nbplane*8+4+4*(4*3+4)

;8*4 (couleurs)
;9*4 (parametres screen)
;2*4 (compatiblit AGA janvier 2003)
;intro_nbplane*8 (adresses bitplanes)
;4 ($FFFFFFFE)
;4*(4*3+4) (wait couleurs page 0)

cop2size=9*4+2*4+16*4+nbplane0*8+4*4+4*5+6*4+3*4+nbplane1*8+4+4*2+4

;9*4 (parametres screen 0)
;2*4 (compatiblit AGA janvier 2003)
;16*4 (couleurs screen 0)
;nbplane0*8 (adresses bitplanes screen 0)
;4*4 (copperline haut)
;4*5 (wait frontiere screen 0/screen 1, $0100, copperline bas)
;6*4 (parametres screen 1)
;3*4 (couleurs screen 1)
;nbplane1*8 (adresses bitplanes screen 1)
;4 ($FFE1FFFE)
;4*2 (wait screen 1, $0100)
;4 ($FFFFFFFE)

;*************** PROGRAMME PRINCIPAL ***************

;----- intro -----

	bsr init_intro
	bsr intro
	bsr fin_intro

;----- saut a l'initialisation du programme principal ------

	bsr init_principal

;----- ecriture du texte dans les bitplanes 1 et 3 -----

	move.w #%0000000000000000,bltcon1
	move.w #%0000110111111100,bltcon0
	move.w #$FFFF,bltafwm
	move.w #$0000,bltalwm
	move.w #fontsizex/8-4,bltamod
	move.w #sizex0/8-4,bltbmod
	move.w #sizex0/8-4,bltdmod
	movea.l plane0.1.3adr,a0
	lea textstart,a1

writeloop0:
	tst.b (a1)
	beq writeloop4		;ne marche que pour les 0 de la premiere ligne
	move.w #%0000110111111100,bltcon0
	moveq #-1,d1
	movea.l a1,a2
writeloop1:
	addq.w #1,d1
	tst.b (a1)+		;compte les chars et...
	bne writeloop1		;...avale le flag 0 de fin de chaine
	move.w d1,d0
	neg d1			;-taille en mot=-moitie de la taille en octet
	addi.w #sizex0/8/2,d1	;a ajouter a la moitie de la taille du screen
	bclr #0,d1		;doit etre une adresse paire
	beq writesuite1		;nb char pair ? si oui pas de decalage de 8
	move.w #%1000110111111100,bltcon0
writesuite1:
	lea (a0,d1.w),a3	;centrage termine
	subq.w #1,d0
writeloop2:

	move.b (a2)+,d1
	move.w #-4,d3
	lea datachar,a4
writeloop3:
	addq.w #4,d3
	move.b (a4)+,d2
	cmp.b d1,d2
	bne.b writeloop3 
	lea datafont,a4
	lea (a4,d3.w),a4
	move.w (a4)+,d1
	mulu #fontplane*fontsizex/8,d1
	add.w (a4),d1

	movea.l #font16.0adr,a4
	lea (a4,d1.w),a4
	move.l a3,bltdpth
	move.l a3,bltbpth
	move.l a4,bltapth
	move.w #2+64*fontplane*16,bltsize
	bsr waitblit
	lea 2(a3),a3
	dbf d0,writeloop2
	lea 16*2*sizex0/8(a0),a0
	tst.b (a1)
	bgt writeloop0
	blt writesuite0
writeloop4:
	addq.l #1,a1
	lea 16*2*sizex0/8(a0),a0
	tst.b (a1)
	beq writeloop4
	bgt writeloop0
writesuite0:

;----- memorisation adresses courbes -----

	move.l curveadr,a0
	move.l curve0adr,(a0)+
	move.l curve1adr,(a0)+
	move.l curve2adr,(a0)+
	move.l curve3adr,(a0)+
	move.l curve4adr,(a0)

;----- creation de la courbe 0 -----

;+++++ pour gagner du temps les fonctions de creation de courbe stockent
;+++++ l'adresse de l'octet du point a afficher et le bit de cette octet !!

	move.l curve0adr,a0
	lea cosinus,a1
	lea sinus,a2
	moveq #2,d3
	moveq #3,d2
	move.w #359,d0
	move.w #360-1,d4
posloop0:
	bsr.w curve0create
	subq.w #1,d0
	dbf d4,posloop0

;----- creation de la courbe 1 -----

	move.l curve1adr,a0
	lea cosinus,a1
	lea sinus,a2
	moveq #2,d3
	moveq #1,d2
	move.w #359,d0
	move.w #360-1,d4
posloop1:
	bsr.w curve0create
	subq.w #1,d0
	dbf d4,posloop1

;----- creation de la courbe 2 -----

	move.l curve2adr,a0
	lea cosinus,a1
	lea sinus,a2
	moveq #2,d3
	moveq #2,d2
	move.w #359,d0
	move.w #360-1,d4
posloop2:
	bsr.w curve0create
	subq.w #1,d0
	dbf d4,posloop2

;----- creation de la courbe 3 -----

	move.l curve3adr,a0
	lea sinus,a1
	lea sinus,a2
	moveq #3,d3
	moveq #2,d2
	move.w #359,d0
	move.w #360-1,d4
posloop3:
	bsr.w curve0create
	subq.w #1,d0
	dbf d4,posloop3

;----- creation de la courbe 4 -----

	move.l curve4adr,a0
	lea sinus,a1
	lea cosinus,a2
	moveq #2,d3
	moveq #4,d2
	move.w #359,d0
	move.w #360-1,d4
posloop4:
	bsr.w curve0create
	subq.w #1,d0
	dbf d4,posloop4

;----- construit les datas du scroll -----

	move.l datascrolladr,a0
	lea scrollstart,a1
	move.w #0,d1
	move.w #0,d2
dataloop0:
	move.b (a1)+,d1
	beq datasuite0
	move.w #-4,d3
	lea datachar,a2
dataloop1:
	addq.w #4,d3
	move.b (a2)+,d2
	cmp.b d1,d2
	bne.b dataloop1 
	lea datafont,a2
	lea (a2,d3.w),a2
	move.w (a2)+,d3
	mulu #nbplane1*fontsizex/8,d3
	add.w (a2),d3
	move.w d3,(a0)+
	jmp dataloop0
datasuite0:

;----- pixelisation du texte ------

;+++++ on analyse chaque lettre et on stocke les 8 octets colonnes de chaque
;+++++ lettre les uns a la suite des autres.

	move.l pixtextadr,a3
	lea stringstart,a0
	lea stringsize(a0),a0
pixloop0:
	moveq #0,d0
	move.b (a0),d0
	lea -1(a0),a0
	beq.B pixsuite0
	subi.b #$20,d0
	lsl.w #3,d0
	lea font8.0adr,a1
	lea (a1,d0.w),a1
	moveq #7,d0	
	moveq #0,d3		;bit colonne
pixloop1:
	move.l a1,a2
	moveq #0,d2		;mot colonne a stocker
	moveq #7,d1		;bit ligne
pixloop2:
	btst d3,(a2)
	beq.B pixsuite1
	bset d1,d2
pixsuite1:
	addi.l #1,a2
	dbf d1,pixloop2
	move.b d2,(a3)+
	addq.b #1,d3
	dbf d0,pixloop1
	jmp pixloop0
pixsuite0:

;----- saut a la coplist 2 -----

	move.l cop2adr,cop1lch		;adresse coplist
	clr.w copjmp1			;copjump1
	move.w #$8180,dmacon		;COPEN et BPLEN

;----- initialisations -----

	bsr mt_init
	move.l plane0buffer,a0
	move.l plane1buffer,a1
	move.l curveadr,a2
	move.w #timer,d5		;compteur de vbl
	move.w #16/scrollspeed-1,d7
	move.w #sizey0,d6
	movea.l datascrolladr,a5
	lea scrollstart,a6

	move.w #0,bltdmod
	move.w #0,bltbmod
	move.w #$0000,bltcon1

;----- programme principal ------

boucle:
	bsr waitvbl
	bsr mt_music

;----- swappe les bitplanes 0 et 2 du screen 0 ------

	move.l cop2adr,a3
	move.w 9*4+2*4+16*4+22(a3),d0
	swap d0
	move.w 9*4+2*4+16*4+18(a3),d0
	move.l a1,d1
	move.w d1,9*4+2*4+16*4+18(a3)
	swap d1
	move.w d1,9*4+2*4+16*4+22(a3)
	move.l d0,a1

	move.w 9*4+2*4+16*4+6(a3),d0
	swap d0
	move.w 9*4+2*4+16*4+2(a3),d0
	move.l a0,d1
	move.w d1,9*4+2*4+16*4+2(a3)
	swap d1
	move.w d1,9*4+2*4+16*4+6(a3)
	move.l d0,a0

;----- hardscrolling des bitplanes 1 et 3 du screen 0 ------

	or.w d6,d6
	bgt hardsuite1
hardsuite0:
	move.w 9*4+2*4+16*4+30(a3),d0
	swap d0
	move.w 9*4+2*4+16*4+26(a3),d0
	subi.l #2*sizex0/8,d0
	move.w d0,9*4+2*4+16*4+26(a3)
	swap d0
	move.w d0,9*4+2*4+16*4+30(a3)
	move.w 9*4+2*4+16*4+14(a3),d0
	swap d0
	move.w 9*4+2*4+16*4+10(a3),d0
	subi.l #2*sizex0/8,d0
	move.w d0,9*4+2*4+16*4+10(a3)
	swap d0
	move.w d0,9*4+2*4+16*4+14(a3)
	subq.w #1,d6
	cmpi.w #-sizey0,d6
	bne hardsuite2
	move.w #sizey0,d6
	jmp hardsuite2
hardsuite1:
	move.w 9*4+2*4+16*4+30(a3),d0
	swap d0
	move.w 9*4+2*4+16*4+26(a3),d0
	addi.l #2*sizex0/8,d0
	move.w d0,9*4+2*4+16*4+26(a3)
	swap d0
	move.w d0,9*4+2*4+16*4+30(a3)
	move.w 9*4+2*4+16*4+14(a3),d0
	swap d0
	move.w 9*4+2*4+16*4+10(a3),d0
	addi.l #2*sizex0/8,d0
	move.w d0,9*4+2*4+16*4+10(a3)
	swap d0
	move.w d0,9*4+2*4+16*4+14(a3)
	subq.w #1,d6
hardsuite2:

;----- efface les bitplanes 0 et 2 du screen 0 ------

;+++++ comme la zone memoire de chacun de ces bitplanes est reserve 
;+++++ l'une a la suite de l'autre, on peut faire ca en une seule copie.

	move.w #%0000000111001100,bltcon0
	move.l a0,bltdpth
	move.w #$0000,bltbdat
	move.w #sizex0/16+64*2*sizey0,bltsize

;----- gere l'affichage du texte -----

	dbra d7,scrollsuite0
	move.w #16/scrollspeed-1,d7
	tst.b (a6)+			;fin du scroll ?
	bne.b scrollsuite1
	lea scrollstart,a6
	addq.l #1,a6
	movea.l datascrolladr,a5	;retour a la premiere lettre
scrollsuite1:
	move.w (a5)+,d0		;offset de la lettre dans le tableau font
	move.l #font16.0adr,a3
	lea (a3,d0.w),a3
	move.l plane1.0.1adr,a4
	lea (sizex1-16)/8(a4),a4
	rept 16*nbplane1
	move.w (a3),(a4)
	lea fontsizex/8(a3),a3
	lea sizex1/8(a4),a4
	endr
scrollsuite0:

;----- scroll dans le screen 1 -----

	bsr.w waitblit
	move.w #%0000010111001100,bltcon0
	move.w #0,bltdmod
	move.w #0,bltbmod
	move.w #scrollspeed,d0
	ror #4,d0
	or.w #$2,d0			;mode ascending
	move.w d0,bltcon1
	move.l plane1.0.1adr,a3
	lea nbplane1*screen1size-2(a3),a3
	move.l a3,bltbpth
	move.l a3,bltdpth
	move.w #sizex1/16+64*nbplane1*sizey1,bltsize

;----- affiche le texte pixelis dans le screen 0 -----

	move.l pixtextadr,a3
	move.l (a2),a4
	moveq #7,d4
	move.w #stringsize*8-1,d3
loop0:
	move.w (a4)+,d1
	move.w (a4)+,d0
	moveq #7,d2
loop1:
	btst d2,(a3)
	beq.b suite1
	bset d0,(a1,d1.w)
	addi.w #ecarty*sizex0/8,d1
	bset d0,(a1,d1.w)
	jmp suite3
suite1:
	addi.w #ecarty*sizex0/8,d1
suite3:
	addi.w #ecarty*sizex0/8,d1
	dbf d2,loop1
	dbf d4,suite2
	exg a0,a1
	moveq #7,d4
suite2:
	addi.l #1,a3
	dbf d3,loop0

;----- cycle les positions de la courbe ------

	bsr.w waitblit
	move.w #$0000,bltcon1
	move.l (a2),a3
	move.l a3,bltdpth
	move.l (a3)+,d0
	move.l a3,bltbpth
	move.w #2+359*64,bltsize
	bsr.w waitblit
	move.l d0,358*4(a3)

;----- decompte des vbl et cycling de courbe et des couleurs -----

	dbra d5,cyclesuite0
	move.w #timer,d5
	move.l (a2),d0
	move.l 4(a2),(a2)
	move.l 8(a2),4(a2)
	move.l 12(a2),8(a2)
	move.l 16(a2),12(a2)
	move.l d0,16(a2)
	lea colorstart,a3
	move.w (a3),d0
	move.w 2(a3),(a3)
	move.w 4(a3),2(a3)
	move.w 6(a3),4(a3)
	move.w 8(a3),6(a3)
	move.w d0,8(a3)
	move.l cop2adr,a4
	move.w (a3),9*4+2*4+6(a4)
cyclesuite0:

	btst #6,$bfe001
	bne.w boucle
	bsr fin_principal
	bsr mt_end

;----- credits -----

	bsr init_credits
	bsr credits
	bsr fin_credits
	rts

;*************** CREDITS ***************

credits:

;----- saut a la coplist 0 -----

	move.l cop0adr,cop1lch		;adresse coplist
	clr.w copjmp1			;copjump1
	move.w #$8180,dmacon		;COPEN et BPLEN

;----- copie de l'image 0 dans les introplanes 0 et 1 -----

	move.w #%0000010111001100,bltcon0
	move.w #$0000,bltcon1
	move.w #0,bltdmod
	move.w #0,bltbmod
	move.l #pic0adr,bltbpth
	move.l introplane0,bltdpth
	move.w #intro_sizex/16+64*intro_sizey,bltsize
	bsr waitblit

	move.w #0,bltdmod
	move.l #pic0adr,a0
	lea picsize(a0),a0
	move.l a0,bltbpth
	move.l introplane1,bltdpth
	move.w #intro_sizex/16+64*intro_sizey,bltsize
	bsr waitblit

;----- programme principal (partie 1) -----

	move.l cop0adr,a0
	lea 8*4+9*4+2*4+8*intro_nbplane+6(a0),a0

	moveq #3,d3
color0loop0:
	moveq #0,d0
	moveq #0,d1
	moveq #0,d2
	move.w #colortimer0,d4
color0loop1:
	rept colortimer1
	bsr waitvbl
	endr
	move.w d0,(a0)
	move.w d1,4(a0)
	move.w d2,8(a0)
	cmpi.w #$0FFF,d0
	beq color0suite0
	addi.w #$0111,d0
color0suite0:
	cmpi.w #$0DDD,d1
	beq color0suite1
	addi.w #$0111,d1
color0suite1:
	cmpi.w #$0BBB,d2
	beq color0suite2
	addi.w #$0111,d2
color0suite2:
	dbf d4,color0loop1
	lea 16(a0),a0
	dbf d3,color0loop0	

;----- delay partie 0/partie 1 -----

	move.w #delaytimer0,d0
delayloop0:
	bsr waitvbl
	dbf d0,delayloop0
 
;----- programme principal (partie 2) -----

	move.l cop0adr,a0
	lea 8*4+9*4+2*4+8*intro_nbplane+6(a0),a0

	moveq #3,d3
color1loop0:
	move.w #$0FFF,d0
	move.w #$0DDD,d1
	move.w #$0BBB,d2
	move.w #colortimer0,d4
color1loop1:
	rept colortimer1
	bsr waitvbl
	endr
	move.w d0,(a0)
	move.w d1,4(a0)
	move.w d2,8(a0)
	or.w d0,d0
	beq color1suite0
	subi.w #$0111,d0
color1suite0:
	or.w d1,d1
	beq color1suite1
	subi.w #$0111,d1
color1suite1:
	or.w d2,d2
	beq color1suite2
	subi.w #$0111,d2
color1suite2:
	dbf d4,color1loop1
	lea 16(a0),a0
	dbf d3,color1loop0	

	rts

;*************** INTRO ***************

intro:

;----- saut a la coplist 1 -----

	move.w #$03F0,dmacon		;couper tout les DMA
	move.l cop1adr,cop1lch		;adresse coplist
	clr.w copjmp1			;copjump1
	move.w #$87C0,dmacon		;BLTEN, COPEN, BPLEN et BLTPRI

;----- copie du bob dans la memoire -----

	move.w #%0000010111001100,bltcon0
	move.w #$0000,bltcon1
	move.w #2,bltdmod
	move.w #0,bltbmod
	move.l #bobpicadr,bltbpth
	move.l bobadr,bltdpth
	move.w #bobsizex/16+64*bobsizey,bltsize
	bsr waitblit

;----- copie de l'image 1 dans les introplanes 0 et 1 -----

	move.w #0,bltdmod
	move.l #pic1adr,bltbpth
	move.l introplane0,bltdpth
	move.w #intro_sizex/16+64*intro_sizey,bltsize
	bsr waitblit

	move.w #0,bltdmod
	move.l #pic1adr,a0
	lea picsize(a0),a0
	move.l a0,bltbpth
	move.l introplane1,bltdpth
	move.w #intro_sizex/16+64*intro_sizey,bltsize
	bsr waitblit

;----- initialisations -----

	move.w #0,bltbmod
	move.w #(intro_sizex-bobsizex-16)/8,bltcmod

	move.w #5,deltabob0x
	move.w #3*intro_sizex/8,deltabob0y
	move.w #-3,deltabob1x
	move.w #-2*intro_sizex/8,deltabob1y

	moveq #0,d0
	moveq #0,d1
	move.w #500,d2
	move.w #240,d3
	move.w #introtimer,d6

;----- programme principal -----

intro_boucle:

	bsr waitvbl

;----- efface l'introplane 2 -----

	move.w #%0000000111001100,bltcon0
	move.w #$0000,bltcon1
	move.w #0,bltdmod
	move.l introplane2,bltdpth
	move.w #$0000,bltbdat
	move.w #intro_sizex/16+64*intro_sizey,bltsize
	bsr waitblit

;----- affichage du projecteur -----

;	move.w #%0000011101100110,bltcon0
	move.w #%0000011111101110,bltcon0
	move.w #(intro_sizex-bobsizex-16)/8,bltdmod
	move.l bobadr,bltbpth
	move.l introplane2,a0
	move.w d0,d4
	move.w d0,d5
	lsr.w #3,d4
	bclr #0,d4
	add.w d1,d4
	lea (a0,d4.w),a0
	and.w #$000F,d5
	ror.w #4,d5
	move.w d5,bltcon1
	move.l a0,bltdpth
	move.l a0,bltcpth
	move.w #(bobsizex+16)/16+64*bobsizey,bltsize
	bsr waitblit

	move.l bobadr,bltbpth
	move.l introplane2,a0
	move.w d2,d4
	move.w d2,d5
	lsr.w #3,d4
	bclr #0,d4
	add.w d3,d4
	lea (a0,d4.w),a0
	and.w #$000F,d5
	ror.w #4,d5
	move.w d5,bltcon1
	move.l a0,bltdpth
	move.l a0,bltcpth
	move.w #(bobsizex+16)/16+64*bobsizey,bltsize
	bsr waitblit

;----- deplacement du projecteur -----

	addi.w deltabob0x,d0
	bge posbob0suite0
	neg deltabob0x
	moveq #0,d0
posbob0suite0:
	cmpi.w #intro_sizex-bobsizex,d0
	ble posbob0suite1
	neg deltabob0x
	addi.w deltabob0x,d0
posbob0suite1:

	addi.w deltabob0y,d1
	bge posbob0suite2
	neg deltabob0y
	moveq #0,d1
posbob0suite2:
	cmpi.w #(intro_sizey-bobsizey)*intro_sizex/8,d1
	ble posbob0suite3
	neg deltabob0y
	addi.w deltabob0y,d1
posbob0suite3:

	addi.w deltabob1x,d2
	bge posbob1suite0
	neg deltabob1x
	moveq #0,d2
posbob1suite0:
	cmpi.w #intro_sizex-bobsizex,d2
	ble posbob1suite1
	neg deltabob1x
	addi.w deltabob1x,d2
posbob1suite1:

	addi.w deltabob1y,d3
	bge posbob1suite2
	neg deltabob1y
	moveq #0,d3
posbob1suite2:
	cmpi.w #(intro_sizey-bobsizey)*intro_sizex/8,d3
	ble posbob1suite3
	neg deltabob1y
	addi.w deltabob1y,d3
posbob1suite3:

	dbf d6,intro_boucle
	rts

;*************** CURVE 0 CREATOR ***************

;+++++ x=A2[D3*angle]
;+++++ y=A1[D2*angle]

;D0=angle
;A0=adresse stockage des coordonnees du point
;A1=sinus ou cosinus
;A2=sinus ou cosinus
;D2=coefficient multiplicatif
;D3=coefficient multiplicatif

curve0create:
	movem.l d0-d3,-(sp)

	move.w d0,d1
	mulu d2,d0		;d0=angle x d2
	mulu d3,d1		;d1=angle x d3
curve0loop0:
	cmpi.w #360,d0
	blt.B curve0suite0
	subi.w #360,d0
	jmp curve0loop0
curve0suite0:
curve0loop1:
	cmpi.w #360,d1
	blt.B curve0suite1
	subi.w #360,d1
	jmp curve0loop1
curve0suite1:
	lsl #1,d0
	lsl #1,d1
	move.w (a1,d0.w),d0
	move.w (a2,d1.w),d1
	muls #amplitudey,d0
	muls #amplitudex,d1
	swap d0
	rol.l #1,d0
	swap d1
	rol.l #1,d1
	addi.w #deltax,d1
	addi.w #deltay,d0
	mulu #sizex0/8,d0
	move.w d1,d2
	lsr.w #3,d1
	add.w d1,d0
	move.w d0,(a0)+
	and.b #%00000111,d2
	not.b d2
	move.w d2,(a0)+
	movem.l (sp)+,d0-d3

	rts

;*************** CURVE 1 CREATOR ***************

;+++++ x=A1[d2*angle]*A2[d3*angle]
;+++++ y=A3[d2*angle]*A4[d3*angle]

;D0=angle
;A0=adresse stockage des coordonnees du point
;A1=sinus ou cosinus
;A2=sinus ou cosinus
;A3=sinus ou cosinus
;A4=sinus ou cosinus
;D2=coefficient multiplicatif
;D3=coefficient multiplicatif

curve1create:
	movem.l d0-d3,-(sp)

	move.w d0,d1
	mulu d2,d0		;d0=d2*angle
	mulu d3,d1		;d1=d3*angle
curve1loop0:
	cmpi.w #360,d0
	blt.B curve1suite0
	subi.w #360,d0
	jmp curve1loop0
curve1suite0:
curve1loop1:
	cmpi.w #360,d1
	blt.B curve1suite1
	subi.w #360,d1
	jmp curve1loop1
curve1suite1:
	lsl #1,d0
	lsl #1,d1
	move.w (a4,d1.w),d2	;d2=A4[d3*angle]
	move.w (a2,d1.w),d3	;d3=A2[d3*angle]
	move.w (a3,d0.w),d1	;d1=A3[d2*angle]
	move.w (a1,d0.w),d0	;d0=A1[d2*angle]

	muls d3,d0
	swap d0
	rol.l #1,d0		;d0=A1[d2*angle]*A2[d3*angle]

	muls d2,d1
	swap d1
	rol.l #1,d1		;d1=A3[d2*angle]*A4[d3*angle]

	muls #amplitudex,d0
	muls #amplitudey,d1
	swap d0
	rol.l #1,d0
	swap d1
	rol.l #1,d1
	addi.w #deltay,d1
	addi.w #deltax,d0
	mulu #sizex0/8,d1
	move.w d0,d2
	lsr.w #3,d0
	add.w d0,d1
	move.w d1,(a0)+
	and.b #%00000111,d2
	not.b d2
	move.w d2,(a0)+
	movem.l (sp)+,d0-d3

	rts

;*************** INITIALISATION CREDITS ***************

init_credits:

;memoire pour copperlist 0

	move.l $4,a6
	move.l #cop0size,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,cop0adr

;memoire pour introplane 0

	move.l #intro_planesize,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,introplane0

;memoire pour introplane 1

	move.l #intro_planesize,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,introplane1

;memoire pour introplane 2

	move.l #intro_planesize,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,introplane2

;creation de la copperlist 0

	move.l cop0adr,a0

	move.l #$01800000,(a0)+
	move.l #$01820000,(a0)+
	move.l #$01840000,(a0)+
	move.l #$01860000,(a0)+
	move.l #$01880000,(a0)+
	move.l #$018A0000,(a0)+
	move.l #$018C0000,(a0)+
	move.l #$018E0000,(a0)+

	move.w #$008E,(a0)+		;DIWSTRT
	move.w #intro_starty*256+intro_startdisplayx,(a0)+
	move.w #$0090,(a0)+		;DIWSTOP
	move.w #intro_stopy*256+intro_stopx,(a0)+
	move.w #$0100,(a0)+		;BPLCON0
	move.w #intro_nbplane,d0
	ror.w #4,d0
	bset #9,d0
	bset #15,d0
	move.w d0,(a0)+
	move.w #$0102,(a0)+		;BPLCON1
	move.w #$0000,(a0)+
	move.w #$0104,(a0)+		;BPLCON2
	move.w #$0000,(a0)+
	move.w #$0092,(a0)+		;DDFSTRT
	move.w #intro_ddf_strt,(a0)+
	move.w #$0094,(a0)+		;DDFSTOP
	move.w #intro_ddf_stop,(a0)+
	move.w #$0108,(a0)+		;BPL1MOD
	move.w #intro_modulo_pair,(a0)+
	move.w #$010A,(a0)+		;BPL2MOD
	move.w #intro_modulo_impair,(a0)+
	move.l #$01FC0000,(a0)+
	move.l #$01060000,(a0)+

	move.l introplane0,d0
	move.w #$E2,(a0)+
	move.w d0,(a0)+
	move.w #$E0,(a0)+
	swap d0
	move.w d0,(a0)+

	move.l introplane1,d0
	move.w #$E6,(a0)+
	move.w d0,(a0)+
	move.w #$E4,(a0)+
	swap d0
	move.w d0,(a0)+

	move.l introplane2,d0
	move.w #$EA,(a0)+
	move.w d0,(a0)+
	move.w #$E8,(a0)+
	swap d0
	move.w d0,(a0)+

	move.w #intro_starty,d0
	lsl.w #8,d0
	or.w #$01,d0
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+
	move.l #$01820000,(a0)+
	move.l #$01840000,(a0)+
	move.l #$01860000,(a0)+

	addi.w #$2400,d0
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+
	move.l #$01820000,(a0)+
	move.l #$01840000,(a0)+
	move.l #$01860000,(a0)+
	addi.w #$0C00,d0

	addi.w #$3400,d0
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+
	move.l #$01820000,(a0)+
	move.l #$01840000,(a0)+
	move.l #$01860000,(a0)+
	addi.w #$0C00,d0

	addi.w #$1600,d0
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+
	move.l #$01820000,(a0)+
	move.l #$01840000,(a0)+
	move.l #$01860000,(a0)+
	addi.w #$0C00,d0

	move.l #$FFFFFFFE,(a0)

	rts

;*************** INITIALISATION INTRO ***************

init_intro:

;memoire pour copperlist 1

	move.l $4,a6
	move.l #cop1size,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,cop1adr

;memoire pour bob

	move.l #(bobsizex+16)*bobsizey/8,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,bobadr

;memoire pour introplane 0

	move.l #intro_planesize,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,introplane0

;memoire pour introplane 1

	move.l #intro_planesize,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,introplane1

;memoire pour introplane 2

	move.l #intro_planesize,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,introplane2

;creation de la copperlist 1

	move.l cop1adr,a0

	move.l #$01800000,(a0)+
	move.l #$01820000,(a0)+
	move.l #$01840000,(a0)+
	move.l #$01860000,(a0)+
	move.l #$01880000,(a0)+
	move.l #$018A0FFF,(a0)+
	move.l #$018C0DDD,(a0)+
	move.l #$018E0BBB,(a0)+

	move.w #$008E,(a0)+		;DIWSTRT
	move.w #intro_starty*256+intro_startdisplayx,(a0)+
	move.w #$0090,(a0)+		;DIWSTOP
	move.w #intro_stopy*256+intro_stopx,(a0)+
	move.w #$0100,(a0)+		;BPLCON0
	move.w #intro_nbplane,d0
	ror.w #4,d0
	bset #9,d0
	bset #15,d0
	move.w d0,(a0)+
	move.w #$0102,(a0)+		;BPLCON1
	move.w #$0000,(a0)+
	move.w #$0104,(a0)+		;BPLCON2
	move.w #$0000,(a0)+
	move.w #$0092,(a0)+		;DDFSTRT
	move.w #intro_ddf_strt,(a0)+
	move.w #$0094,(a0)+		;DDFSTOP
	move.w #intro_ddf_stop,(a0)+
	move.w #$0108,(a0)+		;BPL1MOD
	move.w #intro_modulo_pair,(a0)+
	move.w #$010A,(a0)+		;BPL2MOD
	move.w #intro_modulo_impair,(a0)+
	move.l #$01FC0000,(a0)+
	move.l #$01060000,(a0)+

	move.l introplane0,d0
	move.w #$E2,(a0)+
	move.w d0,(a0)+
	move.w #$E0,(a0)+
	swap d0
	move.w d0,(a0)+

	move.l introplane1,d0
	move.w #$E6,(a0)+
	move.w d0,(a0)+
	move.w #$E4,(a0)+
	swap d0
	move.w d0,(a0)+

	move.l introplane2,d0
	move.w #$EA,(a0)+
	move.w d0,(a0)+
	move.w #$E8,(a0)+
	swap d0
	move.w d0,(a0)+

	move.l #$FFFFFFFE,(a0)

;kill multitache

	jsr forbid(a6)

	rts

;*************** INITIALISATION PROGRAMME PRINCIPAL ***************

init_principal:
	
;memoire pour copperlist 2

	move.l $4,a6
	move.l #cop2size,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,cop2adr

;memoire pour datas scroll

	move.l #2*scrollsize,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,datascrolladr

;memoire pour bitplane 0.0

	move.l #screen0size,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,plane0.0adr

;memoire pour bitplanes 0.2

	move.l #screen0size,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,plane0.2adr

;memoire pour bitplanes 0.1 et 0.3 (raw blitter, double hauteur)

	move.l #2*2*screen0size,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,plane0.1.3adr

;memoire pour bitplanes 1.0 et 1.1 (raw blitter)

	move.l #2*screen1size,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,plane1.0.1adr

;memoire pour planebuffer 0

	move.l #screen0size,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,plane0buffer

;memoire pour planebuffer 1

	move.l #screen0size,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,plane1buffer

;memoire pour texte pixelis

	move.l #stringsize*8*8/8,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,pixtextadr	

;memoire pour courbe 0

	move.l #360*4,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,curve0adr

;memoire pour courbe 1

	move.l #360*4,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,curve1adr

;memoire pour courbe 2

	move.l #360*4,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,curve2adr

;memoire pour courbe 3

	move.l #360*4,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,curve3adr

;memoire pour courbe 4

	move.l #360*4,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,curve4adr

;memoire pour adresses des courbes

	move.l #nbcurve*4,d0
	move.l #memory,d1
	jsr allocmem(a6)
	move.l d0,curveadr

;creation de la copperlist

	move.l cop2adr,a0

;+++++ screen 0

	move.w #$008E,(a0)+		;DIWSTRT
	move.w #starty*256+startdisplayx,(a0)+
	move.w #$0090,(a0)+		;DIWSTOP
	move.w #stopy*256+stopx0,(a0)+
	move.w #$0100,(a0)+		;BPLCON0
	move.w #nbplane0,d0
	ror.w #4,d0
	bset #9,d0
	move.w d0,(a0)+
	move.w #$0102,(a0)+		;BPLCON1
	move.w #$0000,(a0)+
	move.w #$0104,(a0)+		;BPLCON2
	move.w #$0000,(a0)+
	move.w #$0092,(a0)+		;DDFSTRT
	move.w #ddf_strt0,(a0)+
	move.w #$0094,(a0)+		;DDFSTOP
	move.w #ddf_stop0,(a0)+
	move.w #$0108,(a0)+		;BPL1MOD
	move.w #modulo_pair0,(a0)+
	move.w #$010A,(a0)+		;BPL2MOD
	move.w #modulo_impair0,(a0)+
	move.l #$01FC0000,(a0)+
	move.l #$01060000,(a0)+

	move.l #$01800000,(a0)+
	move.w #$0182,(a0)+		;1 couleur pixtext
	lea colorstart,a1
	move.w (a1),(a0)+
	move.l #$01840FFF,(a0)+		;1 couleur text
	move.l #$01860FFF,(a0)+		;1 text/1 pixtext
	move.l #$01880FFF,(a0)+		;2 couleur pixtext
	move.l #$018A0FFF,(a0)+		;int pixtext
	move.l #$018C0FFF,(a0)+		;2 pixtext/1 text
	move.l #$018E0FFF,(a0)+		;2 pixtext/1 text
	move.l #$01900999,(a0)+		;2 couleur text
	move.l #$01920999,(a0)+		;2 text/1 pixtext
	move.l #$01940000,(a0)+		;2 text (pas utilise)
	move.l #$01960000,(a0)+		;2 text/1 pixtext (pas utilise)
	move.l #$01980999,(a0)+		;2 text/2 pixtext
	move.l #$019A0999,(a0)+		;2 text/2 pixtext
	move.l #$019C0000,(a0)+		;2 text/2 pixtext (pas utilise)
	move.l #$019E0000,(a0)+		;2 text/2 pixtext (pas utilise)
	
	move.l plane0.0adr,d0
	move.w #$E2,(a0)+
	move.w d0,(a0)+
	move.w #$E0,(a0)+
	swap d0
	move.w d0,(a0)+

	move.l plane0.1.3adr,d0
	move.w #$E6,(a0)+
	move.w d0,(a0)+
	move.w #$E4,(a0)+
	swap d0
	move.w d0,(a0)+

	move.l plane0.2adr,d0
	move.w #$EA,(a0)+
	move.w d0,(a0)+
	move.w #$E8,(a0)+
	swap d0
	move.w d0,(a0)+

	move.l plane0.1.3adr,d0
	addi.l #sizex0/8,d0
	move.w #$EE,(a0)+
	move.w d0,(a0)+
	move.w #$EC,(a0)+
	swap d0
	move.w d0,(a0)+

	move.w #starty0-1,d0
	lsl.w #8,d0
	or.w #$01,d0
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+
	move.l #$01800FFF,(a0)+
	addi.w #$0100,d0
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+
	move.l #$01800004,(a0)+

	move.w #starty0+sizey0,d0
	lsl.w #8,d0
	or.w #$01,d0
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+
	move.l #$01000000,(a0)+
	move.l #$01800FFF,(a0)+
	addi.w #$0100,d0
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+
	move.l #$01800000,(a0)+

;+++++ screen 1

	move.w #$0090,(a0)+		;DIWSTOP
	move.w #stopy*256+stopx1,(a0)+
	move.w #$0102,(a0)+		;BPLCON1
	move.w #$0000,(a0)+
	move.w #$0092,(a0)+		;DDFSTRT
	move.w #ddf_strt1,(a0)+
	move.w #$0094,(a0)+		;DDFSTOP
	move.w #ddf_stop1,(a0)+
	move.w #$0108,(a0)+		;BPL1MOD
	move.w #modulo_pair1,(a0)+
	move.w #$010A,(a0)+		;BPL2MOD
	move.w #modulo_impair1,(a0)+

	move.l #$01820FFF,(a0)+
	move.l #$01840999,(a0)+
	move.l #$01860000,(a0)+
	
	move.l plane1.0.1adr,d0
	move.w #$E0,d1
	move.w #nbplane1-1,d2
coploop0:
	move.w d1,(a0)+			;registre BPLxPTH
	swap d0				;intervertit poids forts-faibles
	move.w d0,(a0)+			;bouge les poids forts planeadr
	addq.w #2,d1
	move.w d1,(a0)+			;registre BPLxPTL
	swap d0
	move.w d0,(a0)+			;bouge les poids faibles planeadr
	addq.w #2,d1
	addi.l #sizex1/8,d0		;prochain bitplane 
	dbf d2,coploop0

	move.l #$FFE1FFFE,(a0)+
	move.w #starty1,d0
	lsl.w #8,d0
	or.w #$01,d0
	move.w d0,(a0)+
	move.w #$FFFE,(a0)+
	move.w #$0100,(a0)+
	move.w #nbplane1,d0
	ror.w #4,d0
	bset #9,d0
	move.w d0,(a0)+
	move.l #$01800000,(a0)+

	move.l #$FFFFFFFE,(a0)

	rts
	
;*************** FIN CREDITS ***************

fin_credits:

;restaurer la copperlist du dos

	move.l $4,a6
	move.l #grname,a1
	clr.l d0
	jsr openlibrary(a6)
	move.l d0,a4
	move.w #$03F0,dmacon
	move.l 38(a4),cop1lch
	clr.w copjmp1
	move.w #$83F0,dmacon
	jsr permit(a6)

;liberation memoire copper 0

	move.l cop0adr,a1
	move.l #cop0size,d0
	jsr freemem(a6)	

;liberation memoire introplane 0

	move.l introplane0,a1
	move.l #intro_planesize,d0
	jsr freemem(a6)	

;liberation memoire introplane 1

	move.l introplane1,a1
	move.l #intro_planesize,d0
	jsr freemem(a6)	

;liberation memoire introplane 2

	move.l introplane2,a1
	move.l #intro_planesize,d0
	jsr freemem(a6)	

	rts

;*************** FIN INTRO ***************

fin_intro:

	move.w #$0180,dmacon		;couper BPLEN et COPEN

;liberation memoire copper 1

	move.l $4,a6
	move.l cop1adr,a1
	move.l #cop1size,d0
	jsr freemem(a6)	

;liberation memoire bob

	move.l bobadr,a1
	move.l #(bobsizex+16)*bobsizey/8,d0
	jsr freemem(a6)	

;liberation memoire introplane 0

	move.l introplane0,a1
	move.l #intro_planesize,d0
	jsr freemem(a6)	

;liberation memoire introplane 1

	move.l introplane1,a1
	move.l #intro_planesize,d0
	jsr freemem(a6)	

;liberation memoire introplane 2

	move.l introplane2,a1
	move.l #intro_planesize,d0
	jsr freemem(a6)	

	rts

;*************** FIN PROGRAMME PRINCIPAL ***************

fin_principal:

	move.w #$0180,dmacon		;couper BPLEN et COPEN

;liberation memoire copper 2

	move.l $4,a6
	move.l cop2adr,a1
	move.l #cop2size,d0
	jsr freemem(a6)	

;liberation memoire datas scroll

	move.l datascrolladr,a1
	move.l #scrollsize*2,d0
	jsr freemem(a6)	

;liberation memoire biplane 0.0

	move.l plane0.0adr,a1
	move.l #screen0size,d0
	jsr freemem(a6)	

;liberation memoire biplane 0.2

	move.l plane0.2adr,a1
	move.l #screen0size,d0
	jsr freemem(a6)	

;liberation memoire biplane 0.1.3

	move.l plane0.1.3adr,a1
	move.l #2*2*screen0size,d0
	jsr freemem(a6)	

;liberation memoire biplanes 1.0 et 1.1

	move.l plane1.0.1adr,a1
	move.l #2*screen1size,d0
	jsr freemem(a6)	

;liberation memoire planebuffer 0

	move.l plane0buffer,a1
	move.l #screen0size,d0
	jsr freemem(a6)	

;liberation memoire planebuffer 1

	move.l plane1buffer,a1
	move.l #screen0size,d0
	jsr freemem(a6)	

;liberation memoire texte pixelis

	move.l pixtextadr,a1
	move.l #stringsize*8*8/8,d0
	jsr freemem(a6)	

;liberation memoire courbe 0

	move.l curve0adr,a1
	move.l #360*4,d0
	jsr freemem(a6)	

;liberation memoire courbe 1

	move.l curve1adr,a1
	move.l #360*4,d0
	jsr freemem(a6)	

;liberation memoire courbe 2

	move.l curve2adr,a1
	move.l #360*4,d0
	jsr freemem(a6)	

;liberation memoire courbe 3

	move.l curve3adr,a1
	move.l #360*4,d0
	jsr freemem(a6)	

;liberation memoire courbe 4

	move.l curve4adr,a1
	move.l #360*4,d0
	jsr freemem(a6)	

;liberation memoire adresses curves

	move.l curveadr,a1
	move.l #4*nbcurve,d0
	jsr freemem(a6)	

	rts
	
;*************** WAITBLIT ***************

waitblit:
	btst #14,dmaconr
	bne.B waitblit
	rts
	
;*************** LEFTCLICK ***************

leftclick:
	btst #6,$BFE001
	bne.B leftclick
	rts

;*************** ATTENTE ***************

attente:

attente1:
	cmp.b #$39,$bfec01
	bne.B attente1
attente2:
	cmp.b #$37,$bfec01
	bne.B attente2
	rts

;*************** WAITVBL ***************

waitvbl:
	cmp.b #$FF,vhposr
	bne.B waitvbl	
	rts

;*************** NOISETRACKER ROUTINE ***************

*****************************************
* Pro-Packer v2.1 Replay-Routine.	*
* Based upon the PT1.1B-Replayer	*
* by Lars 'ZAP' Hamre/Amiga Freelancers.*
* Modified by Estrup/Static Bytes.	*
*****************************************

; A LITTLE BUG HAS BEEN FOUND AND FIXED IN THE OFFICIAL ONE.
; Revolution / ANALOG.


mt_lev6use=		1		; 0=NO, 1=YES
mt_finetuneused=	0		; 0=NO, 1=YES

mt_init LEA	mt_data,A0
	MOVE.L	A0,mt_SongDataPtr
	LEA	250(A0),A1
	MOVE.W	#511,D0
	MOVEQ	#0,D1
mtloop	MOVE.L	D1,D2
	SUBQ.W	#1,D0
mtloop2	MOVE.B	(A1)+,D1
	CMP.W	D2,D1
	BGT.S	mtloop
	DBRA	D0,mtloop2
	ADDQ	#1,D2

	MOVE.W	D2,D3
	MULU	#128,D3
	ADD.L	#766,D3
	ADD.L	mt_SongDataPtr(PC),D3
	MOVE.L	D3,mt_LWTPtr

	LEA	mt_SampleStarts(PC),A1
	MULU	#128,D2
	ADD.L	#762,D2
	ADD.L	(A0,D2.L),D2
	ADD.L	mt_SongDataPtr(PC),D2
	ADDQ.L	#4,D2
	MOVE.L	D2,A2
	MOVEQ	#30,D0
mtloop3	MOVE.L	A2,(A1)+
	MOVEQ	#0,D1
	MOVE.W	(A0),D1
	ADD.L	D1,D1
	ADD.L	D1,A2
	LEA	8(A0),A0
	DBRA	D0,mtloop3

	OR.B	#2,$BFE001
	lea	mt_speed(PC),A4
	MOVE.B	#6,(A4)
	CLR.B	mt_counter-mt_speed(A4)
	CLR.B	mt_SongPos-mt_speed(A4)
	CLR.W	mt_PatternPos-mt_speed(A4)
mt_end	LEA	$DFF096,A0
	CLR.W	$12(A0)
	CLR.W	$22(A0)
	CLR.W	$32(A0)
	CLR.W	$42(A0)
	MOVE.W	#$F,(A0)
	RTS

mt_music
	MOVEM.L	D0-D4/D7/A0-A6,-(SP)
	LEA	0.w,A4
	ADDQ.B	#1,mt_counter
	MOVE.B	mt_counter(PC),D0
	CMP.B	mt_speed(PC),D0
	BLO.S	mt_NoNewNote
	CLR.B	mt_counter
	TST.B	mt_PattDelTime2
	BEQ.S	mt_GetNewNote
	BSR.S	mt_NoNewAllChannels
	BRA.W	mt_dskip

mt_NoNewNote
	BSR.S	mt_NoNewAllChannels
	BRA.W	mt_NoNewPosYet

mt_NoNewAllChannels
	LEA	$DFF090,A5
	LEA	mt_chan1temp-44(PC),A6
	BSR.W	mt_CheckEfx
	BSR.W	mt_CheckEfx
	BSR.W	mt_CheckEfx
	BRA.W	mt_CheckEfx

mt_GetNewNote
	MOVE.L	mt_SongDataPtr(PC),A0
	LEA	(A0),A3
	LEA	122(A0),A2	;pattpo
	LEA	762(A0),A0	;patterndata
	CLR.W	mt_DMACONtemp

	LEA	$DFF090,A5
	LEA	mt_chan1temp-44(PC),A6
	BSR.S	mt_DoVoice
	BSR.S	mt_DoVoice
	BSR.B	mt_DoVoice
	BSR.B	mt_DoVoice
	BRA.W	mt_SetDMA

mt_DoVoice
	MOVEQ	#0,D0
	MOVEQ	#0,D1
	MOVE.B	mt_SongPos(PC),D0
	LEA	128(A2),A2
	MOVE.B	(A2,D0.W),D1
	MOVE.W	mt_PatternPos(PC),D2
	LSL	#7,D1
	LSR.W	#1,D2
	ADD.W	D2,D1
	LEA	$10(A5),A5
	LEA	44(A6),A6

	TST.L	(A6)
	BNE.S	mt_plvskip
	BSR.W	mt_PerNop
mt_plvskip
	MOVE.W	(A0,D1.W),D1
	LSL.W	#2,D1
	MOVE.L	A0,-(sp)
	MOVE.L	mt_LWTPtr(PC),A0
	MOVE.L	(A0,D1.W),(A6)
	MOVE.L	(sp)+,A0
	MOVE.B	2(A6),D2
	AND.L	#$F0,D2
	LSR.B	#4,D2
	MOVE.B	(A6),D0
	AND.B	#$F0,D0
	OR.B	D0,D2
	BEQ.B	mt_SetRegs
	MOVEQ	#0,D3
	LEA	mt_SampleStarts(PC),A1
	SUBQ	#1,D2
	MOVE	D2,D4
	ADD	D2,D2
	ADD	D2,D2
	LSL	#3,D4
	MOVE.L	(A1,D2.L),4(A6)
	MOVE.W	(A3,D4.W),8(A6)
	MOVE.W	(A3,D4.W),40(A6)
	MOVE.W	2(A3,D4.W),18(A6)
	MOVE.L	4(A6),D2	; Get start
	MOVE.W	4(A3,D4.W),D3	; Get repeat
	BEQ.S	mt_NoLoop
	MOVE.W	D3,D0		; Get repeat
	ADD.W	D3,D3
	ADD.L	D3,D2		; Add repeat
	ADD.W	6(A3,D4.W),D0	; Add replen
	MOVE.W	D0,8(A6)

mt_NoLoop
	MOVE.L	D2,10(A6)
	MOVE.L	D2,36(A6)
	MOVE.W	6(A3,D4.W),14(A6)	; Save replen
	MOVE.B	19(A6),9(A5)	; Set volume
mt_SetRegs
	MOVE.W	(A6),D0
	AND.W	#$0FFF,D0
	BEQ.W	mt_CheckMoreEfx	; If no note

	IF mt_finetuneused=1
	MOVE.W	2(A6),D0
	AND.W	#$0FF0,D0
	CMP.W	#$0E50,D0
	BEQ.S	mt_DoSetFineTune
	ENDC

	MOVE.B	2(A6),D0
	AND.B	#$0F,D0
	CMP.B	#3,D0	; TonePortamento
	BEQ.S	mt_ChkTonePorta
	CMP.B	#5,D0
	BEQ.S	mt_ChkTonePorta
	CMP.B	#9,D0	; Sample Offset
	BNE.S	mt_SetPeriod
	BSR.W	mt_CheckMoreEfx
	BRA.S	mt_SetPeriod

mt_ChkTonePorta
	BSR.W	mt_SetTonePorta
	BRA.W	mt_CheckMoreEfx

mt_DoSetFineTune
	BSR.W	mt_SetFineTune

mt_SetPeriod
	MOVEM.L	D1/A1,-(SP)
	MOVE.W	(A6),D1
	AND.W	#$0FFF,D1

	IF mt_finetuneused=0
	MOVE.W	D1,16(A6)

	ELSE
mt_SetPeriod2
	LEA	mt_PeriodTable(PC),A1
	MOVEQ	#36,D7
mt_ftuloop
	CMP.W	(A1)+,D1
	BHS.S	mt_ftufound
	DBRA	D7,mt_ftuloop
mt_ftufound
	MOVEQ	#0,D1
	MOVE.B	18(A6),D1
	LSL	#3,D1
	MOVE	D1,D0
	LSL	#3,D1
	ADD	D0,D1
	MOVE.W	-2(A1,D1.W),16(A6)
	ENDC

	MOVEM.L	(SP)+,D1/A1

	MOVE.W	2(A6),D0
	AND.W	#$0FF0,D0
	CMP.W	#$0ED0,D0 ; Notedelay
	BEQ.W	mt_CheckMoreEfx

	MOVE.W	20(A6),$DFF096
	BTST	#2,30(A6)
	BNE.S	mt_vibnoc
	CLR.B	27(A6)
mt_vibnoc
	BTST	#6,30(A6)
	BNE.S	mt_trenoc
	CLR.B	29(A6)
mt_trenoc
	MOVE.L	4(A6),(A5)	; Set start
	MOVE.W	8(A6),4(A5)	; Set length
	MOVE.W	16(A6),6(A5)	; Set period
	MOVE.W	20(A6),D0
	OR.W	D0,mt_DMACONtemp
	BRA.W	mt_CheckMoreEfx
 
mt_SetDMA
	IF mt_lev6use=1
	lea	$bfd000,a3
	move.b	#$7f,$d00(a3)
	move.w	#$2000,$dff09c
	move.w	#$a000,$dff09a
	move.l	$78.w,mt_oldirq
	move.l	#mt_irq1,$78.w
	moveq	#0,d0
	move.b	d0,$e00(a3)
	move.b	#$a8,$400(a3)
	move.b	d0,$500(a3)
	move.b	#$11,$e00(a3)
	move.b	#$81,$d00(a3)
	OR.W	#$8000,mt_DMACONtemp
	BRA.w	mt_dskip

	ELSE
	OR.W	#$8000,mt_DMACONtemp
	bsr.w	mt_WaitDMA
	ENDC

	IF mt_lev6use=1
mt_irq1:tst.b	$bfdd00
	MOVE.W	mt_dmacontemp(pc),$DFF096
	move.w	#$2000,$dff09c
	move.l	#mt_irq2,$78.w
	rte

	ELSE
	MOVE.W	mt_dmacontemp(pc),$DFF096
	bsr.w	mt_WaitDMA
	ENDC

	IF mt_lev6use=1
mt_irq2:tst.b	$bfdd00
	movem.l	a5-a6,-(a7)
	ENDC

	LEA	$DFF0A0,A5
	LEA	mt_chan1temp(PC),A6
	MOVE.L	10(A6),(A5)
	MOVE.W	14(A6),4(A5)
	MOVE.L	54(A6),$10(A5)
	MOVE.W	58(A6),$14(A5)
	MOVE.L	98(A6),$20(A5)
	MOVE.W	102(A6),$24(A5)
	MOVE.L	142(A6),$30(A5)
	MOVE.W	146(A6),$34(A5)

	IF mt_lev6use=1
	move.b	#0,$bfde00
	move.b	#$7f,$bfdd00
	move.l	mt_oldirq(pc),$78.w
	move.w	#$2000,$dff09c
	movem.l	(a7)+,a5-a6
	rte
	ENDC

mt_dskip
	lea	mt_speed(PC),A4
	ADDQ.W	#4,mt_PatternPos-mt_speed(A4)
	MOVE.B	mt_PattDelTime-mt_speed(A4),D0
	BEQ.S	mt_dskc
	MOVE.B	D0,mt_PattDelTime2-mt_speed(A4)
	CLR.B	mt_PattDelTime-mt_speed(A4)
mt_dskc	TST.B	mt_PattDelTime2-mt_speed(A4)
	BEQ.S	mt_dska
	SUBQ.B	#1,mt_PattDelTime2-mt_speed(A4)
	BEQ.S	mt_dska
	SUBQ.W	#4,mt_PatternPos-mt_speed(A4)
mt_dska	TST.B	mt_PBreakFlag-mt_speed(A4)
	BEQ.S	mt_nnpysk
	SF	mt_PBreakFlag-mt_speed(A4)
	MOVEQ	#0,D0
	MOVE.B	mt_PBreakPos(PC),D0
	CLR.B	mt_PBreakPos-mt_speed(A4)
	LSL	#2,D0
	MOVE.W	D0,mt_PatternPos-mt_speed(A4)
mt_nnpysk
	CMP.W	#256,mt_PatternPos-mt_speed(A4)
	BLO.S	mt_NoNewPosYet
mt_NextPosition	
	MOVEQ	#0,D0
	MOVE.B	mt_PBreakPos(PC),D0
	LSL	#2,D0
	MOVE.W	D0,mt_PatternPos-mt_speed(A4)
	CLR.B	mt_PBreakPos-mt_speed(A4)
	CLR.B	mt_PosJumpFlag-mt_speed(A4)
	ADDQ.B	#1,mt_SongPos-mt_speed(A4)
	AND.B	#$7F,mt_SongPos-mt_speed(A4)
	MOVE.B	mt_SongPos(PC),D1
	MOVE.L	mt_SongDataPtr(PC),A0
	CMP.B	248(A0),D1
	BLO.S	mt_NoNewPosYet
	CLR.B	mt_SongPos-mt_speed(A4)
mt_NoNewPosYet	
	TST.B	mt_PosJumpFlag-mt_speed(A4)
	BNE.S	mt_NextPosition
	MOVEM.L	(SP)+,D0-D4/D7/A0-A6
	RTS

mt_CheckEfx
	LEA	$10(A5),A5
	LEA	44(A6),A6
	BSR.W	mt_UpdateFunk
	MOVE.W	2(A6),D0
	AND.W	#$0FFF,D0
	BEQ.S	mt_PerNop
	MOVE.B	2(A6),D0
	MOVEQ	#$0F,D1
	AND.L	D1,D0
	BEQ.S	mt_Arpeggio
	SUBQ	#1,D0
	BEQ.W	mt_PortaUp
	SUBQ	#1,D0
	BEQ.W	mt_PortaDown
	SUBQ	#1,D0
	BEQ.W	mt_TonePortamento
	SUBQ	#1,D0
	BEQ.W	mt_Vibrato
	SUBQ	#1,D0
	BEQ.W	mt_TonePlusVolSlide
	SUBQ	#1,D0
	BEQ.W	mt_VibratoPlusVolSlide
	SUBQ	#8,D0
	BEQ.W	mt_E_Commands
SetBack	MOVE.W	16(A6),6(A5)
	ADDQ	#7,D0
	BEQ.W	mt_Tremolo
	SUBQ	#3,D0
	BEQ.W	mt_VolumeSlide
mt_Return2
	RTS

mt_PerNop
	MOVE.W	16(A6),6(A5)
	RTS

mt_Arpeggio
	MOVEQ	#0,D0
	MOVE.B	mt_counter(PC),D0
	DIVS	#3,D0
	SWAP	D0
	TST.W	D0
	BEQ.S	mt_Arpeggio2
	SUBQ	#2,D0
	BEQ.S	mt_Arpeggio1
	MOVEQ	#0,D0
	MOVE.B	3(A6),D0
	LSR.B	#4,D0
	BRA.S	mt_Arpeggio3

mt_Arpeggio2
	MOVE.W	16(A6),6(A5)
	RTS

mt_Arpeggio1
	MOVE.B	3(A6),D0
	AND.W	#15,D0
mt_Arpeggio3
	ADD.W	D0,D0
	LEA	mt_PeriodTable(PC),A0

	IF mt_finetuneused=1
	MOVEQ	#0,D1
	MOVE.B	18(A6),D1
	LSL	#3,D1
	MOVE	D1,D2
	LSL	#3,D1
	ADD	D2,D1
	ADD.L	D1,A0
	ENDC

	MOVE.W	16(A6),D1
	MOVEQ	#36,D7
mt_arploop
	CMP.W	(A0)+,D1
	BHS.S	mt_Arpeggio4
	DBRA	D7,mt_arploop
	RTS

mt_Arpeggio4
	MOVE.W	-2(A0,D0.W),6(A5)
	RTS

mt_FinePortaUp
	TST.B	mt_counter
	BNE.S	mt_Return2
	MOVE.B	#$0F,mt_LowMask
mt_PortaUp
	MOVEQ	#0,D0
	MOVE.B	3(A6),D0
	AND.B	mt_LowMask(PC),D0
	MOVE.B	#$FF,mt_LowMask
	SUB.W	D0,16(A6)
	MOVE.W	16(A6),D0
	AND.W	#$0FFF,D0
	CMP.W	#113,D0
	BPL.S	mt_PortaUskip
	AND.W	#$F000,16(A6)
	OR.W	#113,16(A6)
mt_PortaUskip
	MOVE.W	16(A6),D0
	AND.W	#$0FFF,D0
	MOVE.W	D0,6(A5)
	RTS	
 
mt_FinePortaDown
	TST.B	mt_counter
	BNE.W	mt_Return2
	MOVE.B	#$0F,mt_LowMask
mt_PortaDown
	CLR.W	D0
	MOVE.B	3(A6),D0
	AND.B	mt_LowMask(PC),D0
	MOVE.B	#$FF,mt_LowMask
	ADD.W	D0,16(A6)
	MOVE.W	16(A6),D0
	AND.W	#$0FFF,D0
	CMP.W	#856,D0
	BMI.S	mt_PortaDskip
	AND.W	#$F000,16(A6)
	OR.W	#856,16(A6)
mt_PortaDskip
	MOVE.W	16(A6),D0
	AND.W	#$0FFF,D0
	MOVE.W	D0,6(A5)
	RTS

mt_SetTonePorta
	MOVEM.L	A0,-(SP)
	MOVE.W	(A6),D2
	AND.W	#$0FFF,D2
	LEA	mt_PeriodTable(PC),A0

	IF	mt_finetuneused=1
	MOVEQ	#0,D0
	MOVE.B	18(A6),D0
	ADD	D0,D0
	MOVE	D0,D7
	ADD	D0,D0
	ADD	D0,D0
	ADD	D0,D7
	LSL	#3,D0
	ADD	D7,D0
	ADD.L	D0,A0
	ENDC

	MOVEQ	#0,D0
mt_StpLoop
	CMP.W	(A0,D0.W),D2
	BHS.S	mt_StpFound
	ADDQ	#2,D0
	CMP.W	#37*2,D0
	BLO.S	mt_StpLoop
	MOVEQ	#35*2,D0
mt_StpFound
	BTST	#3,18(A6)
	BEQ.S	mt_StpGoss
	TST.W	D0
	BEQ.S	mt_StpGoss
	SUBQ	#2,D0
mt_StpGoss
	MOVE.W	(A0,D0.W),D2
	MOVE.L	(SP)+,A0
	MOVE.W	D2,24(A6)
	MOVE.W	16(A6),D0
	CLR.B	22(A6)
	CMP.W	D0,D2
	BEQ.S	mt_ClearTonePorta
	BGE.W	mt_Return2
	MOVE.B	#1,22(A6)
	RTS

mt_ClearTonePorta
	CLR.W	24(A6)
	RTS

mt_TonePortamento
	MOVE.B	3(A6),D0
	BEQ.S	mt_TonePortNoChange
	MOVE.B	D0,23(A6)
	CLR.B	3(A6)
mt_TonePortNoChange
	TST.W	24(A6)
	BEQ.W	mt_Return2
	MOVEQ	#0,D0
	MOVE.B	23(A6),D0
	TST.B	22(A6)
	BNE.S	mt_TonePortaUp
mt_TonePortaDown
	ADD.W	D0,16(A6)
	MOVE.W	24(A6),D0
	CMP.W	16(A6),D0
	BGT.S	mt_TonePortaSetPer
	MOVE.W	24(A6),16(A6)
	CLR.W	24(A6)
	BRA.S	mt_TonePortaSetPer

mt_TonePortaUp
	SUB.W	D0,16(A6)
	MOVE.W	24(A6),D0
	CMP.W	16(A6),D0
	BLT.S	mt_TonePortaSetPer
	MOVE.W	24(A6),16(A6)
	CLR.W	24(A6)

mt_TonePortaSetPer
	MOVE.W	16(A6),D2
	MOVE.B	31(A6),D0
	AND.B	#$0F,D0
	BEQ.S	mt_GlissSkip
	LEA	mt_PeriodTable(PC),A0

	IF mt_finetuneused=1
	MOVEQ	#0,D0
	MOVE.B	18(A6),D0
	LSL	#3,D0
	MOVE	D0,D1
	LSL	#3,D0
	ADD	D1,D0
	ADD.L	D0,A0
	ENDC

	MOVEQ	#0,D0
mt_GlissLoop
	CMP.W	(A0,D0.W),D2
	BHS.S	mt_GlissFound
	ADDQ	#2,D0
	CMP.W	#36*2,D0
	BLO.S	mt_GlissLoop
	MOVEQ	#35*2,D0
mt_GlissFound
	MOVE.W	(A0,D0.W),D2
mt_GlissSkip
	MOVE.W	D2,6(A5) ; Set period
	RTS

mt_Vibrato
	MOVE.B	3(A6),D0
	BEQ.S	mt_Vibrato2
	MOVE.B	26(A6),D2
	AND.B	#$0F,D0
	BEQ.S	mt_vibskip
	AND.B	#$F0,D2
	OR.B	D0,D2
mt_vibskip
	MOVE.B	3(A6),D0
	AND.B	#$F0,D0
	BEQ.S	mt_vibskip2
	AND.B	#$0F,D2
	OR.B	D0,D2
mt_vibskip2
	MOVE.B	D2,26(A6)
mt_Vibrato2
	MOVE.B	27(A6),D0
	LEA	mt_VibratoTable(PC),A4
	LSR.W	#2,D0
	AND.W	#$001F,D0
	MOVE.B	30(A6),D2
	AND.W	#$03,D2
	BEQ.S	mt_vib_sine
	LSL.B	#3,D0
	CMP.B	#1,D2
	BEQ.S	mt_vib_rampdown
	MOVE.B	#255,D2
	BRA.S	mt_vib_set
mt_vib_rampdown
	TST.B	27(A6)
	BPL.S	mt_vib_rampdown2
	MOVE.B	#255,D2
	SUB.B	D0,D2
	BRA.S	mt_vib_set
mt_vib_rampdown2
	MOVE.B	D0,D2
	BRA.S	mt_vib_set
mt_vib_sine
	MOVE.B	0(A4,D0.W),D2
mt_vib_set
	MOVE.B	26(A6),D0
	AND.W	#15,D0
	MULU	D0,D2
	LSR.W	#7,D2
	MOVE.W	16(A6),D0
	TST.B	27(A6)
	BMI.S	mt_VibratoNeg
	ADD.W	D2,D0
	BRA.S	mt_Vibrato3
mt_VibratoNeg
	SUB.W	D2,D0
mt_Vibrato3
	MOVE.W	D0,6(A5)
	MOVE.B	26(A6),D0
	LSR.W	#2,D0
	AND.W	#$003C,D0
	ADD.B	D0,27(A6)
	RTS

mt_TonePlusVolSlide
	BSR.W	mt_TonePortNoChange
	BRA.W	mt_VolumeSlide

mt_VibratoPlusVolSlide
	BSR.S	mt_Vibrato2
	BRA.W	mt_VolumeSlide

mt_Tremolo
	MOVE.B	3(A6),D0
	BEQ.S	mt_Tremolo2
	MOVE.B	28(A6),D2
	AND.B	#$0F,D0
	BEQ.S	mt_treskip
	AND.B	#$F0,D2
	OR.B	D0,D2
mt_treskip
	MOVE.B	3(A6),D0
	AND.B	#$F0,D0
	BEQ.S	mt_treskip2
	AND.B	#$0F,D2
	OR.B	D0,D2
mt_treskip2
	MOVE.B	D2,28(A6)
mt_Tremolo2
	MOVE.B	29(A6),D0
	LEA	mt_VibratoTable(PC),A4
	LSR.W	#2,D0
	AND.W	#$001F,D0
	MOVEQ	#0,D2
	MOVE.B	30(A6),D2
	LSR.B	#4,D2
	AND.B	#$03,D2
	BEQ.S	mt_tre_sine
	LSL.B	#3,D0
	CMP.B	#1,D2
	BEQ.S	mt_tre_rampdown
	MOVE.B	#255,D2
	BRA.S	mt_tre_set
mt_tre_rampdown
	TST.B	27(A6)
	BPL.S	mt_tre_rampdown2
	MOVE.B	#255,D2
	SUB.B	D0,D2
	BRA.S	mt_tre_set
mt_tre_rampdown2
	MOVE.B	D0,D2
	BRA.S	mt_tre_set
mt_tre_sine
	MOVE.B	0(A4,D0.W),D2
mt_tre_set
	MOVE.B	28(A6),D0
	AND.W	#15,D0
	MULU	D0,D2
	LSR.W	#6,D2
	MOVEQ	#0,D0
	MOVE.B	19(A6),D0
	TST.B	29(A6)
	BMI.S	mt_TremoloNeg
	ADD.W	D2,D0
	BRA.S	mt_Tremolo3
mt_TremoloNeg
	SUB.W	D2,D0
mt_Tremolo3
	BPL.S	mt_TremoloSkip
	CLR.W	D0
mt_TremoloSkip
	CMP.W	#$40,D0
	BLS.S	mt_TremoloOk
	MOVE.W	#$40,D0
mt_TremoloOk
	MOVE.W	D0,8(A5)
	MOVE.B	28(A6),D0
	LSR.W	#2,D0
	AND.W	#$003C,D0
	ADD.B	D0,29(A6)
	RTS

mt_SampleOffset
	MOVEQ	#0,D0
	MOVE.B	3(A6),D0
	BEQ.S	mt_sononew
	MOVE.B	D0,32(A6)
mt_sononew
	MOVE.B	32(A6),D0
	LSL.W	#7,D0
	CMP.W	8(A6),D0
	BGE.S	mt_sofskip
	SUB.W	D0,8(A6)
	ADD.W	D0,D0
	ADD.L	D0,4(A6)
	RTS
mt_sofskip
	MOVE.W	#$0001,8(A6)
	RTS

mt_VolumeSlide
	MOVEQ	#0,D0
	MOVE.B	3(A6),D0
	LSR.B	#4,D0
	TST.B	D0
	BEQ.S	mt_VolSlideDown
mt_VolSlideUp
	ADD.B	D0,19(A6)
	CMP.B	#$40,19(A6)
	BMI.S	mt_vsuskip
	MOVE.B	#$40,19(A6)
mt_vsuskip
	MOVE.B	19(A6),9(A5)
	RTS

mt_VolSlideDown
	MOVE.B	3(A6),D0
	AND.W	#$0F,D0
mt_VolSlideDown2
	SUB.B	D0,19(A6)
	BPL.S	mt_vsdskip
	CLR.B	19(A6)
mt_vsdskip
	MOVE.B	19(A6),9(A5)
	RTS

mt_PositionJump
	MOVE.B	3(A6),D0
	SUBQ	#1,D0
	MOVE.B	D0,mt_SongPos
mt_pj2	CLR.B	mt_PBreakPos
	ST 	mt_PosJumpFlag
	RTS

mt_VolumeChange
	MOVE.B	3(A6),D0
	CMP.B	#$40,D0
	BLS.S	mt_VolumeOk
	MOVEQ	#$40,D0
mt_VolumeOk
	MOVE.B	D0,19(A6)
	MOVE.B	D0,9(A5)
	RTS

mt_PatternBreak
	MOVEQ	#0,D0
	MOVE.B	3(A6),D0
	MOVE.W	D0,D2
	LSR.B	#4,D0
	ADD	D0,D0
	MOVE	D0,D1
	ADD	D0,D0
	ADD	D0,D0
	ADD	D1,D0
	AND.B	#$0F,D2
	ADD.B	D2,D0
	CMP.B	#63,D0
	BHI.S	mt_pj2
	MOVE.B	D0,mt_PBreakPos
	ST	mt_PosJumpFlag
	RTS

mt_SetSpeed
	MOVE.B	3(A6),D0
	BEQ.W	mt_Return2
	CLR.B	mt_counter
	MOVE.B	D0,mt_speed
	RTS

mt_CheckMoreEfx
	BSR.W	mt_UpdateFunk
	MOVE.B	2(A6),D0
	AND.B	#$0F,D0
	SUB.B	#9,D0
	BEQ.W	mt_SampleOffset
	SUBQ	#2,D0
	BEQ.W	mt_PositionJump
	SUBQ	#1,D0
	BEQ.B	mt_VolumeChange
	SUBQ	#1,D0
	BEQ.S	mt_PatternBreak
	SUBQ	#1,D0
	BEQ.S	mt_E_Commands
	SUBQ	#1,D0
	BEQ.S	mt_SetSpeed
	BRA.W	mt_PerNop

mt_E_Commands
	MOVE.B	3(A6),D0
	AND.W	#$F0,D0
	LSR.B	#4,D0
	BEQ.S	mt_FilterOnOff
	SUBQ	#1,D0
	BEQ.W	mt_FinePortaUp
	SUBQ	#1,D0
	BEQ.W	mt_FinePortaDown
	SUBQ	#1,D0
	BEQ.S	mt_SetGlissControl
	SUBQ	#1,D0
	BEQ.B	mt_SetVibratoControl

	IF mt_finetuneused=1
	SUBQ	#1,D0
	BEQ.B	mt_SetFineTune
	SUBQ	#1,D0

	ELSE
	SUBQ	#2,D0
	ENDC

	BEQ.B	mt_JumpLoop
	SUBQ	#1,D0
	BEQ.W	mt_SetTremoloControl
	SUBQ	#2,D0
	BEQ.W	mt_RetrigNote
	SUBQ	#1,D0
	BEQ.W	mt_VolumeFineUp
	SUBQ	#1,D0
	BEQ.W	mt_VolumeFineDown
	SUBQ	#1,D0
	BEQ.W	mt_NoteCut
	SUBQ	#1,D0
	BEQ.W	mt_NoteDelay
	SUBQ	#1,D0
	BEQ.W	mt_PatternDelay
	BRA.W	mt_FunkIt

mt_FilterOnOff
	MOVE.B	3(A6),D0
	AND.B	#1,D0
	ADD.B	D0,D0
	AND.B	#$FD,$BFE001
	OR.B	D0,$BFE001
	RTS	

mt_SetGlissControl
	MOVE.B	3(A6),D0
	AND.B	#$0F,D0
	AND.B	#$F0,31(A6)
	OR.B	D0,31(A6)
	RTS

mt_SetVibratoControl
	MOVE.B	3(A6),D0
	AND.B	#$0F,D0
	AND.B	#$F0,30(A6)
	OR.B	D0,30(A6)
	RTS

mt_SetFineTune
	MOVE.B	3(A6),D0
	AND.B	#$0F,D0
	MOVE.B	D0,18(A6)
	RTS

mt_JumpLoop
	TST.B	mt_counter
	BNE.W	mt_Return2
	MOVE.B	3(A6),D0
	AND.B	#$0F,D0
	BEQ.S	mt_SetLoop
	TST.B	34(A6)
	BEQ.S	mt_jumpcnt
	SUBQ.B	#1,34(A6)
	BEQ.W	mt_Return2
mt_jmploop 	MOVE.B	33(A6),mt_PBreakPos
	ST	mt_PBreakFlag
	RTS

mt_jumpcnt
	MOVE.B	D0,34(A6)
	BRA.S	mt_jmploop

mt_SetLoop
	MOVE.W	mt_PatternPos(PC),D0
	LSR	#2,D0
	MOVE.B	D0,33(A6)
	RTS

mt_SetTremoloControl
	MOVE.B	3(A6),D0
	AND.B	#$0F,D0
	LSL.B	#4,D0
	AND.B	#$0F,30(A6)
	OR.B	D0,30(A6)
	RTS

mt_RetrigNote
	MOVE.L	D1,-(SP)
	MOVE.B	3(A6),D0
	AND.W	#$0F,D0
	BEQ.S	mt_rtnend
	MOVEQ	#0,d1
	MOVE.B	mt_counter(PC),D1
	BNE.S	mt_rtnskp
	MOVE.W	(A6),D1
	AND.W	#$0FFF,D1
	BNE.S	mt_rtnend
	MOVEQ	#0,D1
	MOVE.B	mt_counter(PC),D1
mt_rtnskp
	DIVU	D0,D1
	SWAP	D1
	TST.W	D1
	BNE.S	mt_rtnend
mt_DoRetrig
	MOVE.W	20(A6),$DFF096	; Channel DMA off
	MOVE.L	4(A6),(A5)	; Set sampledata pointer
	MOVE.W	8(A6),4(A5)	; Set length
	BSR.W	mt_WaitDMA
	MOVE.W	20(A6),D0
	BSET	#15,D0
	MOVE.W	D0,$DFF096
	BSR.W	mt_WaitDMA
	MOVE.L	10(A6),(A5)
	MOVE.L	14(A6),4(A5)
mt_rtnend
	MOVE.L	(SP)+,D1
	RTS

mt_VolumeFineUp
	TST.B	mt_counter
	BNE.W	mt_Return2
	MOVE.B	3(A6),D0
	AND.W	#$F,D0
	BRA.W	mt_VolSlideUp

mt_VolumeFineDown
	TST.B	mt_counter
	BNE.W	mt_Return2
	MOVE.B	3(A6),D0
	AND.W	#$0F,D0
	BRA.W	mt_VolSlideDown2

mt_NoteCut
	MOVE.B	3(A6),D0
	AND.W	#$0F,D0
	CMP.B	mt_counter(PC),D0
	BNE.W	mt_Return2
	CLR.B	19(A6)
	CLR.W	8(A5)
	RTS

mt_NoteDelay
	MOVE.B	3(A6),D0
	AND.W	#$0F,D0
	CMP.B	mt_Counter(PC),D0
	BNE.W	mt_Return2
	MOVE.W	(A6),D0
	BEQ.W	mt_Return2
	MOVE.L	D1,-(SP)
	BRA.W	mt_DoRetrig

mt_PatternDelay
	TST.B	mt_counter
	BNE.W	mt_Return2
	MOVE.B	3(A6),D0
	AND.W	#$0F,D0
	TST.B	mt_PattDelTime2
	BNE.W	mt_Return2
	ADDQ.B	#1,D0
	MOVE.B	D0,mt_PattDelTime
	RTS

mt_FunkIt
	TST.B	mt_counter
	BNE.W	mt_Return2
	MOVE.B	3(A6),D0
	AND.B	#$0F,D0
	LSL.B	#4,D0
	AND.B	#$0F,31(A6)
	OR.B	D0,31(A6)
	TST.B	D0
	BEQ.W	mt_Return2
mt_UpdateFunk
	MOVEM.L	D1/A0,-(SP)
	MOVEQ	#0,D0
	MOVE.B	31(A6),D0
	LSR.B	#4,D0
	BEQ.S	mt_funkend
	LEA	mt_FunkTable(PC),A0
	MOVE.B	(A0,D0.W),D0
	ADD.B	D0,35(A6)
	BTST	#7,35(A6)
	BEQ.S	mt_funkend
	CLR.B	35(A6)

	MOVE.L	10(A6),D0
	MOVEQ	#0,D1
	MOVE.W	14(A6),D1
	ADD.L	D1,D0
	ADD.L	D1,D0
	MOVE.L	36(A6),A0
	ADDQ.L	#1,A0
	CMP.L	D0,A0
	BLO.S	mt_funkok
	MOVE.L	10(A6),A0
mt_funkok
	MOVE.L	A0,36(A6)
	NEG.B	(A0)
	SUBQ.B	#1,(A0)
mt_funkend
	MOVEM.L	(SP)+,D1/A0
	RTS

mt_WaitDMA
	MOVEQ	#3,D0
mt_WaitDMA2
	MOVE.B	$DFF006,D1
mt_WaitDMA3
	CMP.B	$DFF006,D1
	BEQ.S	mt_WaitDMA3
	DBF	D0,mt_WaitDMA2
	RTS

mt_FunkTable dc.b 0,5,6,7,8,10,11,13,16,19,22,26,32,43,64,128

mt_VibratoTable	
	dc.b   0, 24, 49, 74, 97,120,141,161
	dc.b 180,197,212,224,235,244,250,253
	dc.b 255,253,250,244,235,224,212,197
	dc.b 180,161,141,120, 97, 74, 49, 24

mt_PeriodTable
; Tuning 0, Normal
	dc.w	856,808,762,720,678,640,604,570,538,508,480,453
	dc.w	428,404,381,360,339,320,302,285,269,254,240,226
	dc.w	214,202,190,180,170,160,151,143,135,127,120,113
; Tuning 1
	dc.w	850,802,757,715,674,637,601,567,535,505,477,450
	dc.w	425,401,379,357,337,318,300,284,268,253,239,225
	dc.w	213,201,189,179,169,159,150,142,134,126,119,113
; Tuning 2
	dc.w	844,796,752,709,670,632,597,563,532,502,474,447
	dc.w	422,398,376,355,335,316,298,282,266,251,237,224
	dc.w	211,199,188,177,167,158,149,141,133,125,118,112
; Tuning 3
	dc.w	838,791,746,704,665,628,592,559,528,498,470,444
	dc.w	419,395,373,352,332,314,296,280,264,249,235,222
	dc.w	209,198,187,176,166,157,148,140,132,125,118,111
; Tuning 4
	dc.w	832,785,741,699,660,623,588,555,524,495,467,441
	dc.w	416,392,370,350,330,312,294,278,262,247,233,220
	dc.w	208,196,185,175,165,156,147,139,131,124,117,110
; Tuning 5
	dc.w	826,779,736,694,655,619,584,551,520,491,463,437
	dc.w	413,390,368,347,328,309,292,276,260,245,232,219
	dc.w	206,195,184,174,164,155,146,138,130,123,116,109
; Tuning 6
	dc.w	820,774,730,689,651,614,580,547,516,487,460,434
	dc.w	410,387,365,345,325,307,290,274,258,244,230,217
	dc.w	205,193,183,172,163,154,145,137,129,122,115,109
; Tuning 7
	dc.w	814,768,725,684,646,610,575,543,513,484,457,431
	dc.w	407,384,363,342,323,305,288,272,256,242,228,216
	dc.w	204,192,181,171,161,152,144,136,128,121,114,108
; Tuning -8
	dc.w	907,856,808,762,720,678,640,604,570,538,508,480
	dc.w	453,428,404,381,360,339,320,302,285,269,254,240
	dc.w	226,214,202,190,180,170,160,151,143,135,127,120
; Tuning -7
	dc.w	900,850,802,757,715,675,636,601,567,535,505,477
	dc.w	450,425,401,379,357,337,318,300,284,268,253,238
	dc.w	225,212,200,189,179,169,159,150,142,134,126,119
; Tuning -6
	dc.w	894,844,796,752,709,670,632,597,563,532,502,474
	dc.w	447,422,398,376,355,335,316,298,282,266,251,237
	dc.w	223,211,199,188,177,167,158,149,141,133,125,118
; Tuning -5
	dc.w	887,838,791,746,704,665,628,592,559,528,498,470
	dc.w	444,419,395,373,352,332,314,296,280,264,249,235
	dc.w	222,209,198,187,176,166,157,148,140,132,125,118
; Tuning -4
	dc.w	881,832,785,741,699,660,623,588,555,524,494,467
	dc.w	441,416,392,370,350,330,312,294,278,262,247,233
	dc.w	220,208,196,185,175,165,156,147,139,131,123,117
; Tuning -3
	dc.w	875,826,779,736,694,655,619,584,551,520,491,463
	dc.w	437,413,390,368,347,328,309,292,276,260,245,232
	dc.w	219,206,195,184,174,164,155,146,138,130,123,116
; Tuning -2
	dc.w	868,820,774,730,689,651,614,580,547,516,487,460
	dc.w	434,410,387,365,345,325,307,290,274,258,244,230
	dc.w	217,205,193,183,172,163,154,145,137,129,122,115
; Tuning -1
	dc.w	862,814,768,725,684,646,610,575,543,513,484,457
	dc.w	431,407,384,363,342,323,305,288,272,256,242,228
	dc.w	216,203,192,181,171,161,152,144,136,128,121,114

mt_chan1temp	blk.l	5
		dc.w	1
		blk.w	21
		dc.w	2
		blk.w	21
		dc.w	4
		blk.w	21
		dc.w	8
		blk.w	11

mt_SampleStarts	blk.l	31,0

mt_SongDataPtr	dc.l 0
mt_LWTPtr	dc.l 0
mt_oldirq	dc.l 0

mt_speed	dc.b 6
mt_counter	dc.b 0
mt_SongPos	dc.b 0
mt_PBreakPos	dc.b 0
mt_PosJumpFlag	dc.b 0
mt_PBreakFlag	dc.b 0
mt_LowMask	dc.b 0
mt_PattDelTime	dc.b 0
mt_PattDelTime2	dc.b 0,0
mt_PatternPos	dc.w 0
mt_DMACONtemp	dc.w 0
mt_data:	incbin	"sources:darkdata/mod.blitz-packed"

;*************** VARIABLES ***************

bobpicadr:	incbin "sources:darkdata/projecteur.raw"
pic0adr:	incbin "sources:darkdata/darkdata-page2.raw"
pic1adr:	incbin "sources:darkdata/skara brae-page1.raw"
bobadr:		dc.l 0
deltabob0x:	dc.w 0
deltabob0y:	dc.w 0
deltabob1x:	dc.w 0
deltabob1y:	dc.w 0
font8.0adr:	incbin "sources:darkdata/newtopaz.fnt"
pixtextadr:	dc.l 0
introplane0:	dc.l 0
introplane1:	dc.l 0
introplane2:	dc.l 0
plane0.0adr:	dc.l 0
plane0.2adr:	dc.l 0
plane0.1.3adr:	dc.l 0
plane1.0.1adr:	dc.l 0
plane0buffer:	dc.l 0
plane1buffer:	dc.l 0
datascrolladr:	dc.l 0
font16.0adr:	incbin "sources:darkdata/uniplane16-smooth.rawb"
curveadr:	dc.l 0
curve0adr:	dc.l 0
curve1adr:	dc.l 0
curve2adr:	dc.l 0
curve3adr:	dc.l 0
curve4adr:	dc.l 0
oldirq:		dc.l 0
cop0adr:	dc.l 0
cop1adr:	dc.l 0
cop2adr:	dc.l 0
grname:		dc.b 'graphics.library',0
	even

stringstart:
	dc.b 0,'SKARA BRAE BBS'
stringend:
stringsize=stringend-stringstart-1
	even

textstart:
	dc.b 0,0,'skara brae'
	dc.b 0,0,'amiga 2000c'
	dc.b 0,'a2630 33 mhz'
	dc.b 0,'hard drive 300 mo'
	dc.b 0,0,'2*dhst 14400'
	dc.b 0,'1*dhst 16800'
	dc.b 0,0,0,'--- node 0 ---'
	dc.b 0,0,'+49-2154-elite'
	dc.b 0,0,'--- node 1 ---'
	dc.b 0,0,'+49-2154-elite'
	dc.b 0,0,'--- node 2 ---'
	dc.b 0,0,'+49-2154-elite',0,-1
textend:
	even

scrollstart:
	dc.b 'call the skara-brae bbs in germany, voted as one of the '
	dc.b '10 fastest bbs on the planet ....    '
	dc.b 'the board contains over 300 users from all over the world ....    '
	dc.b 'we have 80 calls every day and at the moment 600-700 mb cool new stuff '
	dc.b 'every month ....                   '
	dc.b '! the fastest board around for amiga and pc ! '
	dc.b 'now also supports: \*\ megadrive /*/ famicom \*\ pc engine ....    '
	dc.b 'sysops are: ginger and tci ... (partners in crime and life !!!)    '
	dc.b 'get the cool numbers from any elite-trader in your favourite board !!!'
	dc.b '          cul8er in out of space or here in skara-brae !!!'
	dc.b '                    ',0
scrollend:
scrollsize=scrollend-scrollstart-1
	even


datachar:
	dc.b $61,$62,$63,$64,$65,$66,$67,$68,$69,$6A,$6B,$6C,$6D
	dc.b $6E,$6F,$70,$71,$72,$73,$74,$75,$76,$77,$78,$79,$7A
	dc.b $30,$31,$32,$33,$34,$35,$36,$37,$38,$39
	dc.b $3F,$3D,$3A,$3B,$21,$22,$27,$28,$29,$2B,$2C,$2D,$2E,$2A
	dc.b $2F,$5C,$20
	even

colorstart:
	dc.w $0FF0
	dc.w $0F0F
	dc.w $00F0
	dc.w $0F00
	dc.w $00FF

sinus:
	dc.w 0,572,1144,1715,2286,2856
	dc.w 3425,3993,4560,5126,5690
	dc.w 6252,6813,7371,7927,8481
	dc.w 9032,9580,10126,10668,11207
	dc.w 11743,12275,12803,13328,13848
	dc.w 14365,14876,15384,15886,16384
	dc.w 16877,17364,17847,18324,18795
	dc.w 19261,19720,20174,20622,21063
	dc.w 21498,21926,22348,22763,23170
	dc.w 23571,23965,24351,24730,25102
	dc.w 25466,25822,26170,26510,26842
	dc.w 27166,27482,27789,28088,28378
	dc.w 28660,28932,29196,29452,29698
	dc.w 29935,30163,30382,30592,30792
	dc.w 30983,31164,31336,31499,31651
	dc.w 31795,31928,32052,32166,32270
	dc.w 32365,32449,32524,32588,32643
	dc.w 32688,32723,32748,32763,32767

	dc.w 32763,32748,32723,32688
	dc.w 32643,32588,32524,32449,32365
	dc.w 32270,32166,32052,31928,31795
	dc.w 31651,31499,31336,31164,30983
	dc.w 30792,30592,30382,30163,29935
	dc.w 29698,29452,29196,28932,28660
	dc.w 28378,28088,27789,27482,27166
	dc.w 26842,26510,26170,25822,25466
	dc.w 25102,24730,24351,23965,23571
	dc.w 23170,22763,22348,21926,21498
	dc.w 21063,20622,20174,19720,19261
	dc.w 18795,18324,17847,17364,16877
	dc.w 16384,15886,15384,14876,14365
	dc.w 13848,13328,12803,12275,11743
	dc.w 11207,10668,10126,9580,9032
	dc.w 8481,7927,7371,6813,6252
	dc.w 5690,5126,4560,3993,3425
	dc.w 2856,2286,1715,1144,572,0

	dc.w -572,-1144,-1715,-2286,-2856
	dc.w -3425,-3993,-4560,-5126,-5690
	dc.w -6252,-6813,-7371,-7927,-8481
	dc.w -9032,-9580,-10126,-10668,-11207
	dc.w -11743,-12275,-12803,-13328,-13848
	dc.w -14365,-14876,-15384,-15886,-16384
	dc.w -16877,-17364,-17847,-18324,-18795
	dc.w -19261,-19720,-20174,-20622,-21063
	dc.w -21498,-21926,-22348,-22763,-23170
	dc.w -23571,-23965,-24351,-24730,-25102
	dc.w -25466,-25822,-26170,-26510,-26842
	dc.w -27166,-27482,-27789,-28088,-28378
	dc.w -28660,-28932,-29196,-29452,-29698
	dc.w -29935,-30163,-30382,-30592,-30792
	dc.w -30983,-31164,-31336,-31499,-31651
	dc.w -31795,-31928,-32052,-32166,-32270
	dc.w -32365,-32449,-32524,-32588,-32643
	dc.w -32688,-32723,-32748,-32763,-32767

	dc.w -32763,-32748,-32723,-32688
	dc.w -32643,-32588,-32524,-32449,-32365
	dc.w -32270,-32166,-32052,-31928,-31795
	dc.w -31651,-31499,-31336,-31164,-30983
	dc.w -30792,-30592,-30382,-30163,-29935
	dc.w -29698,-29452,-29196,-28932,-28660
	dc.w -28378,-28088,-27789,-27482,-27166
	dc.w -26842,-26510,-26170,-25822,-25466
	dc.w -25102,-24730,-24351,-23965,-23571
	dc.w -23170,-22763,-22348,-21926,-21498
	dc.w -21063,-20622,-20174,-19720,-19261
	dc.w -18795,-18324,-17847,-17364,-16877
	dc.w -16384,-15886,-15384,-14876,-14365
	dc.w -13848,-13328,-12803,-12275,-11743
	dc.w -11207,-10668,-10126,-9580,-9032
	dc.w -8481,-7927,-7371,-6813,-6252
	dc.w -5690,-5126,-4560,-3993,-3425
	dc.w -2856,-2286,-1715,-1144,-572

cosinus:	
	dc.w 32767,32763,32748,32723,32688
	dc.w 32643,32588,32524,32449,32365
	dc.w 32270,32166,32052,31928,31795
	dc.w 31651,31499,31336,31164,30983
	dc.w 30792,30592,30382,30163,29935
	dc.w 29698,29452,29196,28932,28660
	dc.w 28378,28088,27789,27482,27166
	dc.w 26842,26510,26170,25822,25466
	dc.w 25102,24730,24351,23965,23571
	dc.w 23170,22763,22348,21926,21498
	dc.w 21063,20622,20174,19720,19261
	dc.w 18795,18324,17847,17364,16877
	dc.w 16384,15886,15384,14876,14365
	dc.w 13848,13328,12803,12275,11743
	dc.w 11207,10668,10126,9580,9032
	dc.w 8481,7927,7371,6813,6252
	dc.w 5690,5126,4560,3993,3425
	dc.w 2856,2286,1715,1144,572,0

	dc.w -572,-1144,-1715,-2286,-2856
	dc.w -3425,-3993,-4560,-5126,-5690
	dc.w -6252,-6813,-7371,-7927,-8481
	dc.w -9032,-9580,-10126,-10668,-11207
	dc.w -11743,-12275,-12803,-13328,-13848
	dc.w -14365,-14876,-15384,-15886,-16384
	dc.w -16877,-17364,-17847,-18324,-18795
	dc.w -19261,-19720,-20174,-20622,-21063
	dc.w -21498,-21926,-22348,-22763,-23170
	dc.w -23571,-23965,-24351,-24730,-25102
	dc.w -25466,-25822,-26170,-26510,-26842
	dc.w -27166,-27482,-27789,-28088,-28378
	dc.w -28660,-28932,-29196,-29452,-29698
	dc.w -29935,-30163,-30382,-30592,-30792
	dc.w -30983,-31164,-31336,-31499,-31651
	dc.w -31795,-31928,-32052,-32166,-32270
	dc.w -32365,-32449,-32524,-32588,-32643
	dc.w -32688,-32723,-32748,-32763,-32767

	dc.w -32763,-32748,-32723,-32688
	dc.w -32643,-32588,-32524,-32449,-32365
	dc.w -32270,-32166,-32052,-31928,-31795
	dc.w -31651,-31499,-31336,-31164,-30983
	dc.w -30792,-30592,-30382,-30163,-29935
	dc.w -29698,-29452,-29196,-28932,-28660
	dc.w -28378,-28088,-27789,-27482,-27166
	dc.w -26842,-26510,-26170,-25822,-25466
	dc.w -25102,-24730,-24351,-23965,-23571
	dc.w -23170,-22763,-22348,-21926,-21498
	dc.w -21063,-20622,-20174,-19720,-19261
	dc.w -18795,-18324,-17847,-17364,-16877
	dc.w -16384,-15886,-15384,-14876,-14365
	dc.w -13848,-13328,-12803,-12275,-11743
	dc.w -11207,-10668,-10126,-9580,-9032
	dc.w -8481,-7927,-7371,-6813,-6252
	dc.w -5690,-5126,-4560,-3993,-3425
	dc.w -2856,-2286,-1715,-1144,-572

	dc.w 0,572,1144,1715,2286,2856
	dc.w 3425,3993,4560,5126,5690
	dc.w 6252,6813,7371,7927,8481
	dc.w 9032,9580,10126,10668,11207
	dc.w 11743,12275,12803,13328,13848
	dc.w 14365,14876,15384,15886,16384
	dc.w 16877,17364,17847,18324,18795
	dc.w 19261,19720,20174,20622,21063
	dc.w 21498,21926,22348,22763,23170
	dc.w 23571,23965,24351,24730,25102
	dc.w 25466,25822,26170,26510,26842
	dc.w 27166,27482,27789,28088,28378
	dc.w 28660,28932,29196,29452,29698
	dc.w 29935,30163,30382,30592,30792
	dc.w 30983,31164,31336,31499,31651
	dc.w 31795,31928,32052,32166,32270
	dc.w 32365,32449,32524,32588,32643
	dc.w 32688,32723,32748,32763

datafont:
;A
	dc.w 0,0
;B
	dc.w 0,2
;C
	dc.w 0,4
;D
	dc.w 0,6
;E
	dc.w 0,8
;F
	dc.w 0,10
;G
	dc.w 0,12
;H
	dc.w 0,14
;I
	dc.w 0,16
;J
	dc.w 0,18
;K
	dc.w 0,20
;L
	dc.w 0,22
;M
	dc.w 0,24
;N
	dc.w 0,26
;O
	dc.w 0,28
;P
	dc.w 0,30
;Q
	dc.w 0,32
;R
	dc.w 0,34
;S
	dc.w 0,36
;T
	dc.w 0,38
;U
	dc.w 16,0
;V
	dc.w 16,2
;W
	dc.w 16,4
;X
	dc.w 16,6
;Y
	dc.w 16,8
;Z
	dc.w 16,10
;0
	dc.w 16,12
;1
	dc.w 16,14
;2
	dc.w 16,16
;3
	dc.w 16,18
;4
	dc.w 16,20
;5
	dc.w 16,22
;6
	dc.w 16,24
;7
	dc.w 16,26
;8
	dc.w 16,28
;9
	dc.w 16,30
;?
	dc.w 16,32
;=
	dc.w 16,34
;:
	dc.w 16,36
;;
	dc.w 16,38
;!
	dc.w 32,0
;"	
	dc.w 32,2
;'
	dc.w 32,4
;(
	dc.w 32,6
;)
	dc.w 32,8
;+
	dc.w 32,10
;,
	dc.w 32,12
;-
	dc.w 32,14
;.
	dc.w 32,16
;*
	dc.w 32,18
;/
	dc.w 32,20
;\
	dc.w 32,22
;
	dc.w 32,24
